
#include <SPI.h>
#include "nRF24L01.h"
#include "RF24.h"

RF24 radio(8,9);
const int configpin = 7;
bool config;
const uint64_t txnode = 0xFFFFFFFF01LL;
const uint64_t rxnode = 0xFFFFFFFF02LL;

void setup(void)
{
  pinMode(configpin, INPUT);
  config = digitalRead(configpin);
  radio.begin();
  Serial.begin(57600);
  Serial.print("Initialised as:");
  if (config){
    Serial.println("transmitter");
    radio.openWritingPipe(rxnode);
    radio.openReadingPipe(1,txnode);
  }
  else{
    Serial.println("receiver");
    radio.openWritingPipe(txnode);
    radio.openReadingPipe(1,rxnode);
  }

  radio.startListening();
}

void loop(void)
{

  if (config)  {
    radio.stopListening();
    uint32_t time = millis();
    Serial.print("Now sending ");
    Serial.println(time);
    bool ok = radio.write( &time, 4 );
    if (ok)
      Serial.println("ok...");
    else
      Serial.println("failed.");
    radio.startListening();
    uint32_t start_time = millis();
    bool timeout = false;
    while ( ! radio.available() && ! timeout )
      if (millis() - start_time > 500 )
        timeout = true;
    if ( timeout )
    {
      Serial.println("Failed, response timed out.");
    }
    else
    {
      uint32_t returned_time;
      radio.read( &returned_time, 4 );
      Serial.print("response received. Round trip time (ms):");
      Serial.println(millis()-returned_time);
    }
    // Try again 1s later
    delay(1000);
  }
  else
  {
    if ( radio.available() )
    {
      uint32_t msg_time;
      bool done = false;
      while (!done)
      {
        done = radio.read( &msg_time, sizeof(msg_time));
        Serial.print("Pinged with time value:");
        Serial.println(msg_time);
	delay(25);
      }
      radio.stopListening();
      radio.write( &msg_time, sizeof(msg_time) );
      Serial.println("Sent response.");
      radio.startListening();
    }
  }
}

