
#include <Wire.h>

const int configpin = 7;
bool config;
unsigned char buffer[4];
int Slave=8;
void setup(void)
{
  pinMode(configpin, INPUT);
  config = digitalRead(configpin);
  Serial.begin(9600);
  Serial.print("Initialised as:");
  if (config){
    Serial.println("transmitter");
    Wire.begin();
  }
  else{
    Serial.println("receiver");
    Wire.begin(Slave);
    /// set up callbacks for dealing with slave actions
    Wire.onReceive(slaveRX);
    Wire.onRequest(slaveTX);
  }
  
}

void loop(void)
{
  if (config)  {
    uint32_t time = millis();
    uint32_t start;
    bool timeout = false;
    
    Serial.print("Now sending ");
    Serial.println(time);
    Wire.beginTransmission(Slave);
    Wire.send(0xFF);
    Wire.endTransmission();
    Serial.println("Waiting for response");
   
    delay(20);
    ///Master always initiates any transfer  
    Wire.requestFrom(Slave,1);
    Serial.println("Data requested");
    ///timeout if data not received
    start=millis();
    while (! Wire.available() && ! timeout)
    {
      if (millis() - start > 2500 )
        Serial.print("wire status:");
        Serial.println(Wire.available());
        timeout = true;
    }
    if ( timeout )
    {
      Serial.println("Failed, response timed out.");
    }
    else
    {
      buffer[0]=Wire.receive();
      Serial.print("response received");
      Serial.println(buffer[0],HEX);
      Serial.print("round-trip:");
      Serial.println(millis()-time);
    }

    // Try again later
    delay(2000);
  }
  else
  {
    Serial.print("waiting");
    Serial.println(buffer[0],HEX);
    delay(1000);
  }
}
/// These functions called by wire
void slaveRX(int bytes){
  buffer[0]=Wire.receive();
  Serial.print("value received:");
  Serial.println(buffer[0],HEX);
}

void slaveTX(){
  Serial.println("sending reply");
  Wire.send(&buffer[0],1);
}
